void sequencer()
{
  if (seqRunning)
  {
    if (tickCounter == 0 || tickCounter == (23 + swing))
    {
      if (bitRead(kick[currentStep / 8], 7 - (currentStep % 8)) && voiceActive[0])
      {
        // kick
        index4=0;
        accumulator4=0;
        B4_latch=1;
      }

      if (bitRead(snare[currentStep / 8], 7 - (currentStep % 8)) && voiceActive[1])
      {
        // snare
        index3=0;
        accumulator3=0;
        B3_latch=1;
      }

      if (bitRead(hat[currentStep / 8], 7 - (currentStep % 8))&& voiceActive[2])
      {
        // hat
        index=0;
        accumulator=0;
        B1_latch=1;
      }

      if (bitRead(crash[currentStep / 8], 7 - (currentStep % 8)) && voiceActive[3])
      { 
        // crash
        index2=0;
        accumulator2=0;
        B2_latch=1;
      }

      index_freq_1=0;
      accu_freq_1=0;
      B1_seq_latch=1;

      index_freq_2=0;
      accu_freq_2=0;
      B2_seq_latch=1;

      tickCounter++;
    }

    else 
      tickCounter = (tickCounter == 47) ? 0 : tickCounter + 1;

    if (tickCounter == 0 || tickCounter == (23 + swing))
    {
      if (tickCounter == 0)
        swing = tempSwing;

      if (!repeat)
      {
        currentStep = (currentStep < 31) ? currentStep + 1 : 0;
        trueStep = currentStep;
      }

      else
        trueStep = (trueStep < 31) ? trueStep + 1 : 0;
    }

    if ((tickCounter % 4) == 0)
    {
      midiA.sendRealTime(midi::Clock); // send a midi clock pulse
    }
  }
}








